package cn.iocoder.yudao.module.pms.service.iotdevicetemplate;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotdevicetemplate.vo.IotDeviceTemplatePageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotdevicetemplate.vo.IotDeviceTemplateSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotdevicetemplate.IotDeviceTemplateDO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotmaterial.IotMaterialDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotdevicetemplate.IotDeviceTemplateMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_DEVICE_TEMPLATE_NOT_EXISTS;

/**
 * PMS 功能优化 设备模板 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class IotDeviceTemplateServiceImpl implements IotDeviceTemplateService {

    @Resource
    private IotDeviceTemplateMapper iotDeviceTemplateMapper;

    @Override
    public Long createIotDeviceTemplate(IotDeviceTemplateSaveReqVO createReqVO) {
        // 插入
        IotDeviceTemplateDO iotDeviceTemplate = BeanUtils.toBean(createReqVO, IotDeviceTemplateDO.class);
        iotDeviceTemplateMapper.insert(iotDeviceTemplate);
        // 返回
        return iotDeviceTemplate.getId();
    }

    @Override
    public void updateIotDeviceTemplate(IotDeviceTemplateSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDeviceTemplateExists(updateReqVO.getId());
        // 更新
        IotDeviceTemplateDO updateObj = BeanUtils.toBean(updateReqVO, IotDeviceTemplateDO.class);
        iotDeviceTemplateMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDeviceTemplate(Long id) {
        // 校验存在
        validateIotDeviceTemplateExists(id);
        // 删除
        iotDeviceTemplateMapper.deleteById(id);
    }

    private void validateIotDeviceTemplateExists(Long id) {
        if (iotDeviceTemplateMapper.selectById(id) == null) {
            throw exception(IOT_DEVICE_TEMPLATE_NOT_EXISTS);
        }
    }

    @Override
    public IotDeviceTemplateDO getIotDeviceTemplate(Long id) {
        return iotDeviceTemplateMapper.selectById(id);
    }

    @Override
    public PageResult<IotDeviceTemplateDO> getIotDeviceTemplatePage(IotDeviceTemplatePageReqVO pageReqVO) {
        return iotDeviceTemplateMapper.selectPage(pageReqVO);
    }

    @Override
    public IotDeviceTemplateDO getTemplateByDeviceCategoryId(Long deviceCategoryId) {
        return iotDeviceTemplateMapper.selectByDeviceCategoryId(deviceCategoryId);
    }

    @Override
    public void updateDeviceTemplateStatus(Long id, Integer status) {
        // 校验 设备属性模板 存在
        validateIotDeviceTemplateExists(id);
        // 更新状态
        IotDeviceTemplateDO updateObj = new IotDeviceTemplateDO();
        updateObj.setId(id);
        updateObj.setStatus(status);
        iotDeviceTemplateMapper.updateById(updateObj);
    }

}